// Caches can be used all over the place, and its nice to abstract
// the control logic for them away and put them in a general
// module.  This is that module.

class	CacheLine
	{
	public:
		unsigned	int	RealAddress;
		unsigned	int	Dirty;
		unsigned	int	Valid;
		unsigned	int	PolicyField;
		unsigned	int	SharedField;
	};

class	CacheBank
	{
	public:
		unsigned	int	NumberOfCacheLines;
		CacheLine	*CacheLines;
	};

class	Cache
	{
	public:
		CacheBank	*CacheBanks;
		unsigned	int	NumberOfCacheBanks;	
		unsigned	int	ReplacementPolicy;
		Counter			Hits;
		Counter			Misses;
		Counter			WriteBacks;
		unsigned	int	ShiftAmount;
		unsigned	int	EntryMask;
		unsigned	int	LineSize;
		unsigned	int	LastBankAccess;
	public:
		static	Cache	*CreateCache(
				uint	LineSize,
				uint	BankSize,
				uint	Assoc,
				uint	Policy);
		void	UpdatePolicy(
				int		Bank,
				uint	Entry);
		CacheLine	*LocateInCache(
				uint	aAddress,
				uint	*HitOrMiss,
				uint	*ForcedWriteBack,
				CacheLine	*WrittenCacheLine);
		CacheLine	*IsInCache(
				uint	aAddress);

	};


