#	include	"Simulator.h"


#	include	"SysCallDefinations.h"

bool
MPSystemTrapHandler	::	HandleSystemTrap(
	Processor		*FromProcessor,
	SimInstruction	*AtInstruction)
	{
	SimRegister	*IntegerRegisters = FromProcessor->GetIntegerRegisterSet();

	switch ( IntegerRegisters[2] )
		{
		case	SS_SYS_getcpu:
			return(Perform_SS_SYS_getcpu(FromProcessor,IntegerRegisters));
		case	SS_SYS_fetchadd:
			return(Perform_SS_SYS_fetchadd(FromProcessor,IntegerRegisters));
		case	SS_SYS_fetchdec:
			return(Perform_SS_SYS_fetchdec(FromProcessor,IntegerRegisters));
		default:
			return(SystemTrapHandler::HandleSystemTrap(
				FromProcessor, AtInstruction));
		}
	return ( false );
	}
	

bool
MPSystemTrapHandler	::	Perform_SS_SYS_getcpu(
	Processor	*FromProcessor,
	SimRegister	*regs_R)
	{
	regs_R[2] = FromProcessor->ProcessorNumber;
	regs_R[7] = 0;
	return(true);
	}

bool
MPSystemTrapHandler	::	Perform_SS_SYS_fetchadd(
	Processor	*FromProcessor,
	SimRegister	*regs_R)
	{
	// should really be an instruction, not a sys-call.
	// but for now, i'm not in the mood to add it to gas...
	int		Counter;

	FromProcessor->GetDataMemorySystem()->CopyToHost(
		(void*)&Counter, (void*)regs_R[4], sizeof(int));

	regs_R[2] = Counter;
	regs_R[7] = 0;

	//printf("(%d) INC semaphore(%8.8x), was %d now %d\n",
	//	FromProcessor->ProcessorNumber, regs_R[4],
	//	Counter, Counter+1);
	++Counter;

	//FromProcessor->GetDataMemorySystem()->CopyFromHost(
	//	(void*)regs_R[4], (void*)&Counter, sizeof(int));
	FromProcessor->WriteDataMemory32(regs_R[4], Counter);
	return(true);
	}

bool
MPSystemTrapHandler	::	Perform_SS_SYS_fetchdec(
	Processor	*FromProcessor,
	SimRegister	*regs_R)
	{
	// should really be an instruction, not a sys-call.
	// but for now, i'm not in the mood to add it to gas...
	int		Counter;

	FromProcessor->GetDataMemorySystem()->CopyToHost(
		(void*)&Counter, (void*)regs_R[4], sizeof(int));

	regs_R[2] = Counter;
	regs_R[7] = 0;

	//printf("(%d) DEC semaphore(%8.8x), was %d now %d\n",
	//	FromProcessor->ProcessorNumber, regs_R[4],
	//	Counter, Counter-1);
	--Counter;

	//FromProcessor->GetDataMemorySystem()->CopyFromHost(
	//	(void*)regs_R[4], (void*)&Counter, sizeof(int));
	FromProcessor->WriteDataMemory32(regs_R[4], Counter);
	return(true);
	}
	
