#	include	"Simulator.h"


Resource	::	Resource ()
	{
	ReferenceTime = 0;
	}


bool
Resource	::	RequestNewSchedule (
	int		StartAfter,
	int		Length,
	int		EventId,
	int		*StartsAt,
	int		*EndsAt)
	{
	// Basic idea is look for a "hole" from start to finish where
	// we might schedule this task.
	int		StartedAt, EndingAt, Index;
	int		Time = 0;
	ResourceUse	RU;

	int	Difference = (int)(theSimulator->CycleCount - ReferenceTime);

	if(ResourceUseArray.GetSize())	
	while(Difference > ResourceUseArray[0].Length)
		{
		Difference -= ResourceUseArray[0].Length;
		ResourceUseArray.RemoveAt(0);
		if(!ResourceUseArray.GetSize())
			break;
		}
	if(ResourceUseArray.GetSize())
		ResourceUseArray[0].Length -= Difference;
	ReferenceTime = theSimulator->CycleCount;

	Index = 0;
	while( Index < (ResourceUseArray.GetSize()-1) )
		{
		int OldTime = Time;
		Time += ResourceUseArray[Index].Length;
		if (ResourceUseArray[Index].Filled || 
			(ResourceUseArray[Index].Length < Length) ||
			(Time-Length < StartAfter))
			{
			++Index;
			continue;
			}

		// Found a pocket.  Schedule right after Index
		RU.Length = Length;
		RU.Filled = true;
		RU.EventId = EventId;
		if (OldTime < StartAfter)
			{
			*StartsAt = StartAfter;
			ResourceUseArray[Index].Length -= Length;
			ResourceUseArray.InsertAt(RU, Index+1);
			}
		else
			{
			*StartsAt = OldTime;
			ResourceUseArray[Index].Length -= Length;
			if (!ResourceUseArray[Index].Length)
				ResourceUseArray.RemoveAt(Index);
			ResourceUseArray.InsertAt(RU, Index);
			}


		(*EndsAt)	= *StartsAt + Length;
		return(true);
		}

	// No pocket found.  Schedule at the end
	if (Time < StartAfter)
		{
		RU.Length = StartAfter - Time;
		RU.Filled = false;
		ResourceUseArray.Add(RU);
		Time = StartAfter;
		}

	RU.Length = Length;
	RU.Filled = true;
	RU.EventId = EventId;
	ResourceUseArray.Add(RU);

	(*StartsAt)	= Time;
	(*EndsAt)	= Time+Length;
	
	return ( true );
	}

int
Resource	::	SimulateOneClockCycle ()
	{
	if(ResourceUseArray.GetSize())
		{
		while(ResourceUseArray.GetSize())
			{
			ResourceUseArray[0].Length -= 1;
			if (ResourceUseArray[0].Length <= 0)
				ResourceUseArray.RemoveAt(0); 
			}
		}
	else
		ReferenceTime = 0;
	return(1);
	}

bool
Resource	::	Busy ()
	{

	int	Difference = (int)(theSimulator->CycleCount - ReferenceTime);

	if(ResourceUseArray.GetSize())	
	while(Difference > ResourceUseArray[0].Length)
		{
		Difference -= ResourceUseArray[0].Length;
		ResourceUseArray.RemoveAt(0);
		if(!ResourceUseArray.GetSize())
			break;
		}

	if(ResourceUseArray.GetSize())
		ResourceUseArray[0].Length -= Difference;
	ReferenceTime = theSimulator->CycleCount;
	

	if(ResourceUseArray.GetSize()==0)
		return(false);
	if(ResourceUseArray[0].Filled == false)
		return(false);
	return(true);
	}

void
Resource	::	Clear()
	{
	ResourceUseArray.Clear();
	}
