
class	StandardDRAMDevice	:
	public	MemorySystem
	{
	public:
		uint		AccessLatency, TransferRate;
		int			Transacting;
		Resource	DRAM;
		Resource	FrontSideBus;
		Component	*UpStreamComponent;
		Counter		Accesses;
		Counter		BytesRead;
		Counter		BytesWritten;
		Counter		BusBusyCycles;
		Counter		BusIdleCycles;
		Counter		DRAMBusyCycles;
		Counter		DRAMIdleCycles;
	public:
				StandardDRAMDevice();
		virtual		~StandardDRAMDevice();

		bool	PrintConfiguration (int Format=HumanFormat, FILE *fp=stdout);
		bool	PrintStatistics (int Format=HumanFormat, FILE *fp=stdout);

		bool	Initialize(uint32	aAccessLatency, uint32	aTransferRate);
		bool	Connect(Component	*c);
	public:
		int		SimulateOneClockCycle();
		bool	ScheduleOperation(bool	IsWrite, SimAddress,
					int	Bytes, int	StartAfter,
					int	*UntilStart, int *UntilFinish);
	};

