
// The System trap handler (unlike other components)
// does not take a clock.  It is a completly fake I/O device
// that provides an interface to the underlying operating system
// Furthermore, it is not a real "component" for now.  Maybe
// that will change.

class	AlphaProcessor;
class	AlphaInstruction;

typedef	struct	_FlagTranslationTableEntry
	{
	uint64		AlphaFlag;
	uint		NativeFlag;
	}	FlagTranslationTableEntry;

#	define	LastFlagEntry	{	0,	0	}	
	
class	OSFSystemTrapHandler
	{
	public:
				bool	SystemCallTrace;

	public:
		virtual	bool	HandleSystemTrap(
					AlphaProcessor				*FromProcessor,
					AlphaInstruction			*AtInstruction);
				bool	Initialize ( bool	aSystemCallTrace )
						{
						SystemCallTrace = aSystemCallTrace;
						return ( true );
						}
	protected:
		virtual	bool	Perform_OSF_SYS_exit(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_fork(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_vfork(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_read(AlphaProcessor *, uint64 *);

		virtual	bool	Perform_OSF_SYS_open(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_write(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_close(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_creat(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_unlink(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_chdir(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_chmod(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_chown(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_brk(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_lseek(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_getuid(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_access(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_stat(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_lstat(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_dup(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_pipe(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_getgid(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_ioctl(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_fstat(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_getpagesize(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_fsync(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_dup2(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_fcntl(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_select(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_gettimeofday(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_OSF_SYS_obreak(AlphaProcessor *, uint64 *);

		virtual	bool	Perform_MP_FetchAndInc(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_FetchAndDec(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_GetCPU(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_Spawn(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_GetConfig(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_ICareNow(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_Pause(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_MP_Unpause(AlphaProcessor *, uint64 *);

		virtual	bool	Perform_Unimplemented(AlphaProcessor *, uint64 *);
		virtual	bool	Perform_Implemented(AlphaProcessor *, uint64 *);

				bool	TranslateFlagsAlphaToNative(uint	*NativeFlags, uint64	*AlphaFlags, FlagTranslationTableEntry	*);
				bool	TranslateFlagsNativeToAlpha(uint64	*AlphaFlags, uint		*NativeFlags, FlagTranslationTableEntry	*);
	};

